3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 USAGE="[--quiet] [--cached] \
8 [add <repo> [-b branch] <path>]|[status|init|update [-i|--init]|summary [-n|--summary-limit <n>] [<commit>]] \
9 [--] [<path>...]|[foreach <command>]|[sync [--] [<path>...]]"
21 # print stuff on stdout unless -q was specified
31 # Resolve relative url by appending to parent's url
32 resolve_relative_url ()
34 remote=$(get_default_remote)
35 remoteurl=$(git config "remote.$remote.url") ||
36 die "remote ($remote) does not have a url defined in .git/config"
38 remoteurl=${remoteurl%/}
44 remoteurl="${remoteurl%/*}"
53 echo "$remoteurl/${url%/}"
57 # Get submodule info for registered submodules
58 # $@ = path to limit submodule list
62 git ls-files --stage -- "$@" | grep '^160000 '
66 # Map submodule path to submodule name
72 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
73 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
74 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
75 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
77 die "No submodule mapping found in .gitmodules for path '$path'"
84 # Prior to calling, cmd_update checks that a possibly existing
85 # path is not a git repository.
86 # Likewise, cmd_add checks that path does not exist at all,
87 # since it is the location of a new submodule.
94 # If there already is a directory at the submodule path,
95 # expect it to be empty (since that is the default checkout
96 # action) and try to remove it.
97 # Note: if $path is a symlink to a directory the test will
98 # succeed but the rmdir will fail. We might want to fix this.
101 rmdir "$path" 2>/dev/null ||
102 die "Directory '$path' exist, but is neither empty nor a git repository"
106 die "A file already exist at path '$path'"
108 git-clone -n "$url" "$path" ||
109 die "Clone of '$url' into submodule path '$path' failed"
113 # Add a new submodule to the working tree, .gitmodules and the index
117 # optional branch is stored in global branch variable
121 # parse $args after "submodule ... add".
126 case "$2" in '') usage ;; esac
150 if test -z "$repo" -o -z "$path"; then
154 # assure repo is absolute or relative to parent
157 # dereference source url relative to parent's url
158 realrepo=$(resolve_relative_url "$repo") || exit
165 die "repo URL: '$repo' must be absolute or begin with ./|../"
169 # strip trailing slashes from path
170 path=$(echo "$path" | sed -e 's|/*$||')
172 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
173 die "'$path' already exists in the index"
175 # perhaps the path exists and is already a git repo, else clone it
178 if test -d "$path"/.git -o -f "$path"/.git
180 echo "Adding existing repo at '$path' to the index"
182 die "'$path' already exists and is not a valid git repo"
187 url=$(resolve_relative_url "$repo") || exit
193 git config submodule."$path".url "$url"
196 module_clone "$path" "$realrepo" || exit
197 (unset GIT_DIR; cd "$path" && git checkout -f -q ${branch:+-b "$branch" "origin/$branch"}) ||
198 die "Unable to checkout submodule '$path'"
202 die "Failed to add submodule '$path'"
204 git config -f .gitmodules submodule."$path".path "$path" &&
205 git config -f .gitmodules submodule."$path".url "$repo" &&
206 git add .gitmodules ||
207 die "Failed to register submodule '$path'"
211 # Execute an arbitrary command sequence in each checked out
214 # $@ = command to execute
219 while read mode sha1 stage path
221 if test -e "$path"/.git
223 say "Entering '$path'"
224 (cd "$path" && eval "$@") ||
225 die "Stopping at '$path'; script returned non-zero status."
231 # Register submodules in .git/config
233 # $@ = requested paths (default to all)
237 # parse $args after "submodule ... init".
259 while read mode sha1 stage path
261 # Skip already registered paths
262 name=$(module_name "$path") || exit
263 url=$(git config submodule."$name".url)
264 test -z "$url" || continue
266 url=$(git config -f .gitmodules submodule."$name".url)
268 die "No url found for submodule path '$path' in .gitmodules"
270 # Possibly a url relative to parent
273 url=$(resolve_relative_url "$url") || exit
277 git config submodule."$name".url "$url" ||
278 die "Failed to register url for submodule path '$path'"
280 say "Submodule '$name' ($url) registered for path '$path'"
285 # Update each submodule path to correct revision, using clone and checkout as needed
287 # $@ = requested paths (default to all)
291 # parse $args after "submodule ... update".
301 cmd_init "$@" || return
317 while read mode sha1 stage path
319 name=$(module_name "$path") || exit
320 url=$(git config submodule."$name".url)
323 # Only mention uninitialized submodules when its
324 # path have been specified
326 say "Submodule path '$path' not initialized"
327 say "Maybe you want to use 'update --init'?"
331 if ! test -d "$path"/.git -o -f "$path"/.git
333 module_clone "$path" "$url" || exit
336 subsha1=$(unset GIT_DIR; cd "$path" &&
337 git rev-parse --verify HEAD) ||
338 die "Unable to find current revision in submodule path '$path'"
341 if test "$subsha1" != "$sha1"
344 if test -z "$subsha1"
348 (unset GIT_DIR; cd "$path" && git-fetch &&
349 git-checkout $force -q "$sha1") ||
350 die "Unable to checkout '$sha1' in submodule path '$path'"
352 say "Submodule path '$path': checked out '$sha1'"
361 git describe "$2" 2>/dev/null ||
362 git describe --tags "$2" 2>/dev/null ||
363 git describe --contains "$2" 2>/dev/null ||
364 git describe --all --always "$2"
367 test -z "$revname" || revname=" ($revname)"
370 # Show commit summary for submodules in index or working tree
372 # If '--cached' is given, show summary between index and given commit,
373 # or between working tree and given commit
375 # $@ = [commit (default 'HEAD'),] requested paths (default all)
381 # parse $args after "submodule ... summary".
392 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
414 test $summary_limit = 0 && return
416 if rev=$(git rev-parse --verify "$1^0" 2>/dev/null)
425 # Get modified modules cared by user
426 modules=$(git diff-index $cached --raw $head -- "$@" |
427 egrep '^:([0-7]* )?160000' |
428 while read mod_src mod_dst sha1_src sha1_dst status name
430 # Always show modules deleted or type-changed (blob<->module)
431 test $status = D -o $status = T && echo "$name" && continue
432 # Also show added or modified modules which are checked out
433 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
438 test -z "$modules" && return
440 git diff-index $cached --raw $head -- $modules |
441 egrep '^:([0-7]* )?160000' |
443 while read mod_src mod_dst sha1_src sha1_dst status name
445 if test -z "$cached" &&
446 test $sha1_dst = 0000000000000000000000000000000000000000
450 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
452 100644 | 100755 | 120000)
453 sha1_dst=$(git hash-object $name)
459 echo >&2 "unexpected mode $mod_dst"
466 test $mod_src = 160000 &&
467 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_src^0 >/dev/null 2>&1 &&
470 test $mod_dst = 160000 &&
471 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_dst^0 >/dev/null 2>&1 &&
475 case "$missing_src,$missing_dst" in
477 errmsg=" Warn: $name doesn't contain commit $sha1_src"
480 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
483 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
488 if test $mod_src = 160000 -a $mod_dst = 160000
490 range="$sha1_src...$sha1_dst"
491 elif test $mod_src = 160000
497 GIT_DIR="$name/.git" \
498 git log --pretty=oneline --first-parent $range | wc -l
500 total_commits=" ($(($total_commits + 0)))"
504 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
505 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
508 if test $mod_dst = 160000
510 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
512 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
515 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
519 # Don't give error msg for modification whose dst is not submodule
520 # i.e. deleted or changed to blob
521 test $mod_dst = 160000 && echo "$errmsg"
523 if test $mod_src = 160000 -a $mod_dst = 160000
526 test $summary_limit -gt 0 && limit="-$summary_limit"
527 GIT_DIR="$name/.git" \
528 git log $limit --pretty='format: %m %s' \
529 --first-parent $sha1_src...$sha1_dst
530 elif test $mod_dst = 160000
532 GIT_DIR="$name/.git" \
533 git log --pretty='format: > %s' -1 $sha1_dst
535 GIT_DIR="$name/.git" \
536 git log --pretty='format: < %s' -1 $sha1_src
542 if test -n "$for_status"; then
543 echo "# Modified submodules:"
545 sed -e 's|^|# |' -e 's|^# $|#|'
551 # List all submodules, prefixed with:
552 # - submodule not initialized
553 # + different revision checked out
555 # If --cached was specified the revision in the index will be printed
556 # instead of the currently checked out revision.
558 # $@ = requested paths (default to all)
562 # parse $args after "submodule ... status".
587 while read mode sha1 stage path
589 name=$(module_name "$path") || exit
590 url=$(git config submodule."$name".url)
591 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
596 set_name_rev "$path" "$sha1"
597 if git diff-files --quiet -- "$path"
599 say " $sha1 $path$revname"
603 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
604 set_name_rev "$path" "$sha1"
606 say "+$sha1 $path$revname"
611 # Sync remote urls for submodules
612 # This makes the value for remote.$remote.url match the value
613 # specified in .gitmodules.
638 while read mode sha1 stage path
640 name=$(module_name "$path")
641 url=$(git config -f .gitmodules --get submodule."$name".url)
643 # Possibly a url relative to parent
646 url=$(resolve_relative_url "$url") || exit
650 if test -e "$path"/.git
655 remote=$(get_default_remote)
656 say "Synchronizing submodule url for '$name'"
657 git config remote."$remote".url "$url"
663 # This loop parses the command line arguments to find the
664 # subcommand name to dispatch. Parsing of the subcommand specific
665 # options are primarily done by the subcommand implementations.
666 # Subcommand specific options such as --branch and --cached are
667 # parsed here as well, for backward compatibility.
669 while test $# != 0 && test -z "$command"
672 add | foreach | init | update | status | summary | sync)
702 # No command word defaults to "status"
703 test -n "$command" || command=status
705 # "-b branch" is accepted only by "add"
706 if test -n "$branch" && test "$command" != add
711 # "--cached" is accepted only by "status" and "summary"
712 if test -n "$cached" && test "$command" != status -a "$command" != summary